<?php
// Configuración de la base de datos
$servername = "localhost"; // Reemplaza con tu servidor de base de datos
$username = "toromot1_root";
$password = "pluton007$";
$dbname = "toromot1_doli";

// Crear conexión
$conn = new mysqli($servername, $username, $password, $dbname);

// Verificar conexión
if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}

// Consulta SQL
$sql = "SELECT DISTINCT 
    p.ref as COD, 
    p.label as p_label, 
    FORMAT(p.price_ttc, 2, 'de_DE') as p_price_ttc, 
    p.barcode as p_barcode, 
    extra.parte as extra_parte 
FROM 
    llx_product as p 
LEFT JOIN 
    llx_product_extrafields as extra ON p.rowid = extra.fk_object 
WHERE 
    p.fk_product_type = 0 
    AND p.entity IN (1) 
    -- AND extra.parte = 1
    AND p.stock != 0
    
	Order by p_label asc;";

$result = $conn->query($sql);
$productos = [];
if ($result->num_rows > 0) {
    while($row = $result->fetch_assoc()) {
        $productos[] = $row;
    }
}

$conn->close();
$totalProductos = count($productos);
?>

<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Etiquetas de Productos</title>
    <style>
        body {
            font-family: Arial, sans-serif;
            margin: 20px;
        }
        .etiqueta {
            border: 1px solid #000;
            display: inline-block;
            padding: 10px;
            text-align: center;
            margin: 10px;
            width: 350px; /* Ajusta el ancho según tus necesidades */
            height: 120px; /* Ajusta la altura según tus necesidades */
            box-shadow: 2px 2px 5px rgba(0, 0, 0, 0.2);
            border-radius: 5px;
        }
        @media print {
            button {
                display: none;
            }
            .etiqueta {
                page-break-inside: avoid;
            }
        }
        .pagination {
            margin: 20px 0;
        }
        .pagination button {
            margin: 0 5px;
            padding: 5px 10px;
        }
    </style>
</head>
<body>

<h1>Etiquetas de Productos</h1>

<form id="formulario">
    <label for="fuente">Tamaño de Fuente:</label>
    <select id="fuente" onchange="cambiarTamañoFuente()">
        <option value="10">10</option>
        <option value="12">12</option>
        <option value="14">14</option>
        <option value="16">16</option>
        <option value="18">18</option>
        <option value="20">20</option>
        <option value="22">22</option>
    </select>
    
    <label for="tamañoEtiqueta">Tamaño de Etiqueta:</label>
    <select id="tamañoEtiqueta" onchange="cambiarTamañoEtiqueta()">
        <option value="150">150px</option>
        <option value="200">200px</option>
        <option value="250">250px</option>
        <option value="300">300px</option>
        <option value="350">350px</option>
        <option value="400">400px</option>
    </select>

    <!-- <label for="tipoCodigo">Tipo de Código de Barras:</label>
    <select id="tipoCodigo" onchange="cambiarTipoCodigo()">
        <option value="code128">Código 128</option>
        <option value="code39">Código 39</option>
        <option value="codabar">Codabar</option>
    </select> -->

    <!-- <label for="tamañoCodigo">Tamaño del Código de Barras:</label>
    <select id="tamañoCodigo" onchange="cambiarTamañoCodigo()">
        <option value="20">20px</option>
        <option value="30">30px</option>
        <option value="40">40px</option>
    </select> -->
</form>

<div id="etiquetas">
    <?php foreach ($productos as $producto): ?>
        <div class="etiqueta" style="font-size: <?= isset($_GET['fuente']) ? $_GET['fuente'] : 16 ?>px;">
            <strong>**TORO CLARINES**</strong> <br>
			<strong>Cod:</strong> <?= $producto['COD'] ?><br>
           <strong></strong> <strong><?= $producto['p_label'] ?></strong><br>
          <strong>REF:</strong> <strong style="font-size: 1.5em;"><?= $producto['p_price_ttc'] ?></strong><br>
           
            <?php if (!empty($producto['p_barcode'])): ?>
               <img src="barcode.php?text=<?= $producto['p_barcode'] ?>" alt="Código de barras" class="codigo-barras" style="width:200px; height:auto;"/>
            <?php else: ?>
                <span>No hay código de barras disponible</span>
            <?php endif; ?>
        </div>
    <?php endforeach; ?>
</div>

<div class="pagination">
    <button onclick="imprimirEtiquetas()">Imprimir Todas las Etiquetas</button>
    <button onclick="cambiarPagina(-1)">Anterior</button>
    <button onclick="cambiarPagina(1)">Siguiente</button>
    <button onclick="irAPrimeraPagina()">Primera Página</button>
    <button onclick="irALaUltimaPagina()">Última Página</button>
    <span>Página <span id="paginaActual">1</span> de <span id="totalPaginas"></span></span>
</div>

<script>
let paginaActual = 0;
const etiquetasPorPagina = 20; // Cambia este valor según cuántas etiquetas quieras por página
const totalProductos = <?= $totalProductos ?>;

function actualizarTotalPaginas() {
    const totalPaginas = Math.ceil(totalProductos / etiquetasPorPagina);
    document.getElementById('totalPaginas').innerText = totalPaginas;
}

function cambiarTamañoFuente() {
    const fuente = document.getElementById('fuente').value;
    document.querySelectorAll('.etiqueta').forEach(etiqueta => {
        etiqueta.style.fontSize = fuente + 'px';
    });
}

function cambiarTamañoEtiqueta() {
    const tamañoEtiqueta = document.getElementById('tamañoEtiqueta').value;
    document.querySelectorAll('.etiqueta').forEach(etiqueta => {
        etiqueta.style.width = tamañoEtiqueta + 'px';
    });
}

function cambiarTipoCodigo() {
    const tipoCodigo = document.getElementById('tipoCodigo').value;
    cambiarCodigoBarras(tipoCodigo, document.getElementById('tamañoCodigo').value);
}

function cambiarTamañoCodigo() {
    const tamañoCodigo = document.getElementById('tamañoCodigo').value;
    const tipoCodigo = document.getElementById('tipoCodigo').value;
    cambiarCodigoBarras(tipoCodigo, tamañoCodigo);
}

function cambiarCodigoBarras(tipo, tamaño) {
    const etiquetas = document.querySelectorAll('.etiqueta img.codigo-barras');
    etiquetas.forEach((img, index) => {
        const codigo = <?= json_encode(array_column($productos, 'p_barcode')) ?>[index];
        img.src = `barcode.php?code=${codigo}&type=${tipo}&size=${tamaño}`;
        img.style.width = tamaño + 'px'; // Ajusta el tamaño de la imagen
    });
}

function cambiarPagina(direccion) {
    const etiquetas = document.querySelectorAll('.etiqueta');
    const totalPaginas = Math.ceil(etiquetas.length / etiquetasPorPagina);
    paginaActual += direccion;

    if (paginaActual < 0) {
        paginaActual = 0;
    } else if (paginaActual >= totalPaginas) {
        paginaActual = totalPaginas - 1;
    }

    etiquetas.forEach((etiqueta, index) => {
        etiqueta.style.display = (index >= paginaActual * etiquetasPorPagina && index < (paginaActual + 1) * etiquetasPorPagina) ? 'inline-block' : 'none';
    });

    document.getElementById('paginaActual').innerText = paginaActual + 1;
}

// Imprimir todas las etiquetas
function imprimirEtiquetas() {
    const etiquetas = document.querySelectorAll('.etiqueta');
    etiquetas.forEach(etiqueta => {
        etiqueta.style.display = 'inline-block'; // Asegura que todas se muestren
    });
    window.print(); // Imprime
    etiquetas.forEach(etiqueta => {
        etiqueta.style.display = ''; // Restablece la visibilidad
    });
}

// Ir a la primera página
function irAPrimeraPagina() {
    paginaActual = 0;
    cambiarPagina(0);
}

// Ir a la última página
function irALaUltimaPagina() {
    paginaActual = Math.ceil(totalProductos / etiquetasPorPagina) - 1;
    cambiarPagina(0);
}

// Inicializa la visualización de las etiquetas
cambiarPagina(0);
actualizarTotalPaginas();
</script>

</body>
</html>
